const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

function loadBuilder()
{
  //get default builder contractid
  var pbs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService); 
  var contract = pbs.getBranch("urlnav.builder.").getCharPref("default");
      
  //loop through builders
  var catMgr = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
  var entries = catMgr.enumerateCategory("urlnav-builders");
  var defaults = document.getElementById("listDefault");
  var builders = document.getElementById("listBuilder");
  while (entries.hasMoreElements()) {
    var entry = entries.getNext().QueryInterface(Components.interfaces.nsISupportsCString).data;
    var current = catMgr.getCategoryEntry("urlnav-builders", entry);
    var builder = Components.classes[current].createInstance(Components.interfaces.navIBuilder);
      
    //create menuitem and select if default
    var item = defaults.appendItem(builder.name, current);
    if (current == contract)
      defaults.selectedItem = item;
      
    //create richlistitem  
    item = document.createElementNS(XUL_NS, "builder");
    builders.appendChild(item);
    item.component = builder;      
  };
};